package org.artifactory.servicetrust;

import lombok.Data;

import java.util.regex.Pattern;

/**
 * @author igoru
 */
@Data
public class ServiceTrustUseCase {

    public static final ServiceTrustUseCase
            ARTIFACTORY_COLD = new ServiceTrustUseCase(
            "artifactory-cold", "^artifactory-cold$", ServiceTrust.ONE_WAY);
    public static final ServiceTrustUseCase ARTIFACTORY_COLD_WITH_NAMESPACE =
            new ServiceTrustUseCase("artifactory-cold",
                    "^artifactory-cold/.+$",
                    ServiceTrust.ONE_WAY);

    private final String name;
    private final Pattern pattern;
    private final ServiceTrust trust;

    ServiceTrustUseCase(String name, String pattern, ServiceTrust trust) {
        this.name = name;
        this.pattern = Pattern.compile(pattern);
        this.trust = trust;
    }

    boolean matches(String candidate) {
        return pattern.matcher(candidate).matches();
    }

}
