package org.artifactory.storage.db.upgrades.common;

import org.artifactory.common.home.ArtifactoryHome;
import org.artifactory.storage.db.AsyncDatabaseConverterAdapter;
import org.jetbrains.annotations.NotNull;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;

/**
 * @author Alexei Vainshtein
 */
public class DatabaseTestConverterAdapter extends AsyncDatabaseConverterAdapter {

    private ScheduledExecutorService executorService;

    public DatabaseTestConverterAdapter(ArtifactoryHome artifactoryHome) {
        super(artifactoryHome);
    }

    @NotNull
    protected ScheduledExecutorService getScheduledExecutorService() {
        if (executorService == null) {
            executorService = Executors.newScheduledThreadPool(1);
        }
        return executorService;
    }
}
